> For the complete documentation index, see [llms.txt](https://docs.umbraco.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.umbraco.com/ai-in-umbraco/17.latest/management-api/versions/history.md).

# Get History

Returns a paginated list of versions for a specific entity.

## Request

```http
GET /umbraco/ai/management/api/v1/versions/{entityType}/{entityId}
```

### Path Parameters

| Parameter    | Type   | Description                                                         |
| ------------ | ------ | ------------------------------------------------------------------- |
| `entityType` | string | Entity type (`connection`, `profile`, `context`, `prompt`, `agent`) |
| `entityId`   | guid   | Entity unique identifier                                            |

### Query Parameters

| Parameter | Type | Default | Description                  |
| --------- | ---- | ------- | ---------------------------- |
| `skip`    | int  | 0       | Number of versions to skip   |
| `take`    | int  | 10      | Number of versions to return |

## Response

### Success

{% code title="200 OK" %}

```json
{
    "currentVersion": 5,
    "totalVersions": 5,
    "versions": [
        {
            "id": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
            "entityId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
            "version": 5,
            "dateCreated": "2024-01-25T09:15:00Z",
            "createdByUserId": "d290f1ee-6c54-4b01-90e6-d701748f0851",
            "createdByUserName": "admin@example.com",
            "changeDescription": "Updated system prompt"
        },
        {
            "id": "b2c3d4e5-f6a7-8901-bcde-f23456789012",
            "entityId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
            "version": 4,
            "dateCreated": "2024-01-22T16:30:00Z",
            "createdByUserId": "d290f1ee-6c54-4b01-90e6-d701748f0851",
            "createdByUserName": "admin@example.com",
            "changeDescription": "Changed temperature to 0.8"
        },
        {
            "id": "c3d4e5f6-a7b8-9012-cdef-345678901234",
            "entityId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
            "version": 3,
            "dateCreated": "2024-01-20T14:45:00Z",
            "createdByUserId": "d290f1ee-6c54-4b01-90e6-d701748f0851",
            "createdByUserName": "admin@example.com",
            "changeDescription": null
        }
    ]
}
```

{% endcode %}

### Response Properties

| Property         | Type  | Description                            |
| ---------------- | ----- | -------------------------------------- |
| `currentVersion` | int   | The current version of the entity      |
| `totalVersions`  | int   | The total number of versions available |
| `versions`       | array | List of version entries                |

### Version Entry Properties

| Property            | Type     | Description                                          |
| ------------------- | -------- | ---------------------------------------------------- |
| `id`                | guid     | Unique identifier of the version record              |
| `entityId`          | guid     | ID of the entity this version belongs to             |
| `version`           | int      | The version number                                   |
| `dateCreated`       | datetime | When this version was created                        |
| `createdByUserId`   | guid     | User key of the user who created this version        |
| `createdByUserName` | string   | Display name of the user who created this version    |
| `changeDescription` | string   | Optional description of what changed in this version |

### Not Found

{% code title="404 Not Found" %}

```json
{
    "type": "https://tools.ietf.org/html/rfc7231#section-6.5.4",
    "title": "Not Found",
    "status": 404,
    "detail": "Entity not found"
}
```

{% endcode %}

## Examples

{% code title="cURL" %}

```bash
curl -X GET "https://your-site.com/umbraco/ai/management/api/v1/versions/profile/3fa85f64-5717-4562-b3fc-2c963f66afa6?skip=0&take=10" \
  -H "Authorization: Bearer YOUR_ACCESS_TOKEN"
```

{% endcode %}

{% code title="C#" %}

```csharp
var entityType = "profile";
var entityId = Guid.Parse("3fa85f64-5717-4562-b3fc-2c963f66afa6");

var response = await httpClient.GetAsync(
    $"/umbraco/ai/management/api/v1/versions/{entityType}/{entityId}?skip=0&take=10");
var history = await response.Content.ReadFromJsonAsync<PagedResult<AIEntityVersionModel>>();
```

{% endcode %}

## Notes

* Versions are returned in descending order (newest first)
* The `changeDescription` may be null if no description was provided when the version was created
* History does not include the snapshot data - use the [Get Version](/ai-in-umbraco/17.latest/management-api/versions/get-version.md) endpoint to retrieve full snapshots


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.umbraco.com/ai-in-umbraco/17.latest/management-api/versions/history.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
